using System;
using System.Windows.Forms;

namespace viaticum
{
	/// <summary>
	/// Summary description for Debug.
	/// </summary>
	public sealed class Debug
	{
		static bool on = true;
		static bool On 
		{
			get { return on; }
			set { on = value; }
		}

		public static void WriteLine(string s)
		{
			if (on) {MessageBox.Show(s);}
		}
		public static void WriteLine(object o)
		{
			if (on) {WriteLine(o.ToString());}
		}

	}
}
