using System;
using System.Collections;
using System.Text;
//using OpenNETCF.Security.Cryptography;
//using OpenNETCF.Security.Cryptography.NativeMethods; 
using System.Security.Cryptography;

namespace viaticum
{
	/// <summary>
	/// Summary description for Des3Crypt.
	/// </summary>
	public class Des3Crypt
	{
		private TripleDESCryptoServiceProvider des3;
		private byte[] key;
		private byte[] iv;

		public Des3Crypt(string key)
		{
			int i;
			MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();
			SHA1CryptoServiceProvider sha1 = new SHA1CryptoServiceProvider();
			byte[] md5_hash = md5.ComputeHash(Encoding.Unicode.GetBytes(key));
			byte[] sha1_hash = sha1.ComputeHash(Encoding.Unicode.GetBytes(key));

			this.key = new byte[24];
			this.iv  = new byte[8];

			for (i=0; i<20; i++) 
			{
				this.key[i] = sha1_hash[i];
				if (i < 4) 
				{
					this.key[i + 20] = md5_hash[i*2];
				}
			}
			for (i=0; i<8; i++) 
			{
				this.iv[i] = md5_hash[i];
			}
			
			des3 = new TripleDESCryptoServiceProvider();
			des3.Key = this.key;
			des3.IV  = this.iv;			
		}

		public string encrypt(string data) // returns Base64 encoded string
		{
			byte[] strAsBytes = Encoding.UTF8.GetBytes(data);
            byte[] encrypted = null; // des3.EncryptValue(strAsBytes);


			return (System.Convert.ToBase64String(encrypted, 0, encrypted.Length));
		}

		public string decrypt(string data) // gets data as Base64 encoded string
		{
			byte[] buff = System.Convert.FromBase64String(data);

            byte[] ds = null; // des3.DecryptValue(buff);
			return(Encoding.UTF8.GetString(ds, 0, ds.Length));
		}
		public byte[] binary_encrypt(string data)
		{
			byte[] strAsBytes = Encoding.UTF8.GetBytes(data);

            return null; // (des3.EncryptValue(strAsBytes));
		}

		public string binary_decrypt(byte[] data)
		{
            byte[] ds = null; // des3.DecryptValue(data);

			return(Encoding.UTF8.GetString(ds, 0, ds.Length));
		}

	}
}
