using System;

namespace viaticum
{
	/// <summary>
	/// Summary description for Query.
	/// </summary>
	public class Query
	{
		public static bool qAve2Passenger(int ageFrom, int ageTo, int reqMaxNumPers, bool canSmoke, Context.EnumGender gender, Context.EnumDirections direction)
		{
			return (Context.Identcard.MyAge >= ageFrom && Context.Identcard.MyAge <= ageTo
				&&
				(!Context.ReqMaySmoke || canSmoke)
				&&
				(gender == Context.EnumGender.unspezifiziert ||
				Context.Identcard.MyGender == gender)
				&&
				direction == Context.ReqDirection
				&&
				reqMaxNumPers > Context.ReqNumPers
				); 
		}
		
		public static bool qAve2Driver(int ageFrom, int ageTo, bool canSmoke, Context.EnumGender gender, Context.EnumDirections direction)
		{
			return (Context.Identcard.MyAge >= ageFrom && Context.Identcard.MyAge <= ageTo
				&&
				(!Context.ReqMaySmoke || canSmoke)
				&&
				(gender == Context.EnumGender.unspezifiziert ||
				Context.Identcard.MyGender == gender)
				&&
				direction == Context.ReqDirection
				); 
		}
	}
}
